* QERR342_bin - Qlib's ERRor suit
*
* V3.36,  Liberation Software, 1993
* V3.42, pjw, 2021 Oct 06
*
* This code is identical to sys_Qlib3_asm, so used instead of Qlib3


        section code

        filetype 0

; 
start   equ     *
        lea     L000A,a1
        movea.w $00000110,a2    * BI_INIPR
        jmp     (a2)
; 
L000A   dc.w    $0004           * Extra room needed due to long names
        dc.w    L00CA-*
        dc.b    $08,'Q_ERR_ON',$00
        dc.w    L006C-*
        dc.b    $09,'Q_ERR_OFF'
        dc.w    L005E-*
        dc.b    $0A,'Q_ERR_LIST',$00
        dc.w    $0000
        dc.w    $0001
        dc.w    L0040-*
        dc.b    $05,'Q_ERR'
        dc.w    $0000

;       BASIC - Function  'Q_ERR'
L0040   moveq   #$02,d1
        movea.w $0000011A,a2
        jsr     (a2)
        movea.l $0058(a6),a1
        subq.l  #$02,a1
        move.w  $00C2(a6),$00(a6,a1.l)
        move.l  a1,$0058(a6)
        moveq   #$03,d4
        moveq   #$00,d0
        rts
; 
;       BASIC - Procedure 'Q_ERR_LIST'
L005E   st      d7
        move.l  $0030(a6),d0
        movea.l $00(a6,d0.l),a0
        movea.l (a0),a0
        bra.s   L0072
;       BASIC - Procedure 'Q_ERR_OFF'
L006C   sf      d7
        cmpa.l  a3,a5
          bne.s L00CC
L0072   movea.l $0018(a6),a2
        movea.l $001C(a6),a3
L007A   move.w  $00(a6,a2.l),d0
        cmpi.w  #$0800,d0
          bne.s L00B6
        move.l  $04(a6,a2.l),d2
          bpl.s L00B6
        tst.b   d7
          beq.s L00B4
        move.w  $02(a6,a2.l),d0
        movea.l $0020(a6),a1
        adda.w  d0,a1
        move.w  sr,d6
        trap    #$00            * SMS_SUPERV
        adda.l  a6,a1
        moveq   #$00,d2
        move.b  (a1)+,d2
        suba.l  a0,a0
        moveq   #-$01,d3
        moveq   #$07,d0         * IOB_SMUL
        trap    #$03
        move.w  d6,sr
        moveq   #$20,d1
        moveq   #$05,d0         * IOB_SBYT
        trap    #$03
        bra.s   L00B6
L00B4   bsr.s   L0110
L00B6   addq.l  #$08,a2
        cmpa.l  a2,a3
          bne.s L007A
        tst.b   d7
          beq.s L00C6
        moveq   #$0A,d1
        moveq   #$05,d0         * IOB_SBYT
        trap    #$03
L00C6   moveq   #$00,d0
        rts
; 
;       BASIC - Procedure 'Q_ERR_ON'
L00CA   st      d7
L00CC   movea.l a5,a4
L00CE   cmpa.l  a3,a4
          beq.s L0106
        lea     $0008(a3),a5
        movea.w $00000116,a2
        jsr     (a2)
          bne.s L0106
        move.w  $00(a6,a1.l),d0
        lea     $0002(a1),a0
        bsr     L019A
          bne.s L00FE
        cmpi.w  #$0800,d1
          bne.s L0104
        tst.b   d7
          beq.s L0108
        bsr.s   L011E
          bne.s L0106
L00FA   movea.l a5,a3
        bra.s   L00CE
L00FE   tst.l   $0054(a6)
          beq.s L00FA
L0104   moveq   #-$0F,d0        * ERR_IPAR
L0106   rts
; 
L0108   tst.l   d2
          bpl.s L0104
        bsr.s   L0110
        bra.s   L00FA
L0110   lsl.l   #$01,d2
        lsr.l   #$01,d2
        movea.l d2,a0
        move.l  -(a0),$04(a6,a2.l)
        clr.l   (a0)
        rts
; 
L011E   tst.l   $04(a6,a2.l)
          bmi.s L0198
        move.l  $00DC(a6),d0
          bne.s L016A
L012A   movem.l a2-a3,-(a7)
        moveq   #-$01,d2
        move.l  #$00000200,d1
        moveq   #$18,d0         * SMS_ACHP
        trap    #$01
        movem.l (a7)+,a2-a3
        tst.l   d0
          bne.s L0198
        move.l  $00DC(a6),d0
        move.l  a0,$00DC(a6)
        move.l  d0,(a0)+
        moveq   #$1B,d1
L014E   clr.l   (a0)+
        move.l  #$207AFFFA,(a0)+
        move.l  #$4E903D40,(a0)+
        move.l  #$00C27000,(a0)+
        move.w  #$4E75,(a0)+
        dbf     d1,L014E
L016A   movea.l $00DC(a6),a0
L016E   moveq   #$1B,d1
        move.l  (a0)+,d0
L0172   tst.l   (a0)
          beq.s L0186
        adda.w  #$0012,a0
        dbf     d1,L0172
        tst.l   d0
          beq.s L012A
        movea.l d0,a0
        bra.s   L016E
L0186   move.l  $04(a6,a2.l),(a0)+
        move.l  a0,d0
        ori.l   #$80000000,d0
        move.l  d0,$04(a6,a2.l)
        moveq   #$00,d0
L0198   rts
; 
L019A   movem.l a3-a4,-(a7)
        movea.l $0018(a6),a2
L01A2   movea.w $02(a6,a2.l),a4
        adda.l  $0020(a6),a4
        cmp.b   $00(a6,a4.l),d0
          beq.s L01C0
L01B0   addq.l  #$08,a2
        cmpa.l  $001C(a6),a2
          bls.s L01A2
        movem.l (a7)+,a3-a4
        moveq   #-$07,d0        * ERR_FDNF
        rts
; 
L01C0   addq.l  #$01,a4
        move.w  d0,d1
        subq.w  #$01,d1
        movea.l a0,a3
L01C8   move.b  $00(a6,a4.l),d2
        move.b  $00(a6,a3.l),d3
        ori.b   #$20,d2
        ori.b   #$20,d3
        cmp.b   d2,d3
          bne.s L01B0
        addq.l  #$01,a3
        addq.l  #$01,a4
        dbf     d1,L01C8
        movem.l (a7)+,a3-a4
        move.w  $00(a6,a2.l),d1
        move.l  $04(a6,a2.l),d2
        moveq   #$00,d0
        rts
; 
L01F4   equ     *
        end
